﻿Type=Class
Version=2.52
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private NewValue As String
	Private MinValue As Short
	Private MaxValue As Short
	Private exponent As Short 'maxvalue and minvalue refers to the integer value after multiplying with the exponent
	Private PLCreg As PLCRegister
	Private LabelValuePLCFromReg As Label
	Private LabelPLCRegStatus As Label
	Private EditTextPLCToReg As EditText
	Private LabelsPLCRegName As Label
	Private PLCRegname As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize()
End Sub

Public Sub Init(InitPLCreg As PLCRegister, PresentationID As Short)
	PLCreg = InitPLCreg
	PLCreg.AddPresentation(Me)
	NewValue = ""
	MinValue = StateManager.GetSetting2("MinValue" & PresentationID,-32768)
	MaxValue = StateManager.GetSetting2("MaxValue" & PresentationID,32767)
	exponent = StateManager.GetSetting2("exponent" & PresentationID,0)
	PLCRegname = StateManager.GetSetting2("PLCRegname" & PresentationID, "SL adresse " & PLCreg.Index)
End Sub

Public Sub CreateViews(Args  As CreatPresentationViewsType) As Int 'Returns the top for the next Presentation
		
		Dim L As Label
		L.Initialize("LabelsValuePLCFromReg")
		L.TextColor = Colors.Black
		L.Gravity = Gravity.RIGHT + Gravity.CENTER_VERTICAL
		L.Color = Colors.LightGray
		Args.P.AddView(L,Args.PanelWidth -  70dip, Args.top ,  50dip,Main.ItemHeight)
		LabelValuePLCFromReg = L
	
		Dim LS As Label
		LS.Initialize("LabelPLCRegStatus")
		LS.TextColor = L.TextColor
		LS.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
		LS.Color = Colors.LightGray
		Args.P.AddView(LS,Args.PanelWidth - 30, Args.top ,  15dip,Main.ItemHeight)
		LabelPLCRegStatus = LS

		If PLCreg.Index <= 24 Then
			Dim ET As EditText
			ET.Initialize("EditTextPLCToReg")
			ET.Tag = PLCreg.Index
			ET.TextColor = Colors.Black
			ET.TextSize = 14
			ET.InputType = ET.INPUT_TYPE_DECIMAL_NUMBERS
			ET.ForceDoneButton = True
			ET.Gravity = Gravity.RIGHT + Gravity.CENTER_VERTICAL
			ET.Color = Colors.White
			Args.P.AddView(ET,L.Left-53dip,Args.top ,50dip,Main.ItemHeight)
			
			Dim r As Reflector
    		r.Target = ET
    		'Set padding to minimum
    		r.RunMethod4("setPadding", Array As Object(0, 1dip, 0, 0), Array As String("java.lang.int", "java.lang.int", "java.lang.int", "java.lang.int"))
			
			EditTextPLCToReg = ET
		End If
				
		Dim LN As Label
		LN.Initialize("LabelsPLCRegName")
		LN.TextColor = Colors.Black
		LN.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
		LN.Color = Colors.Transparent
		LN.Text = PLCRegname
		If PLCreg.Index <= 24 Then
			Args.P.AddView(LN,5dip,Args.top ,ET.Left-3dip ,Main.ItemHeight)
		Else
			Args.P.AddView(LN,5dip,Args.top ,L.Left-3dip ,Main.ItemHeight)
		End If
		LabelsPLCRegName = LN

		PLCregValueChanged
		
		Return Args.top + Main.LineHeight
End Sub

Public Sub DestroyViews
	LabelValuePLCFromReg = Null
	LabelPLCRegStatus = Null
	EditTextPLCToReg = Null
	LabelsPLCRegName = Null
End Sub

Public Sub Destroy
		PLCreg.RemovePresentation(Me)
End Sub

Sub PLCregValueChanged
		If PLCreg.Thrustable Then
			LabelPLCRegStatus.Text = ""
		Else
			LabelPLCRegStatus.Text = "?"
		End If
		If PLCreg.Loaded Then
			LabelValuePLCFromReg.Text = PLCreg.Value / Power(10, exponent)
		Else
			LabelValuePLCFromReg.Text = ""
		End If

		If PLCreg.Index <= 24 Then 
			EditTextPLCToReg.Text = NewValue
		End If
End Sub

Sub PLCregNewValueReceived
	NewValue = ""
	PLCregValueChanged
End Sub

Sub EditTextPLCToReg_TextChanged (Old As String, New As String)
	Dim ET = Sender As EditText
	Dim Value As Long
	Try
		Dim pwr = Power(10,exponent) As Long
		Value = New * pwr
		If Value > MaxValue OR Value < MinValue OR (Value / pwr <> New AND Not(New.EndsWith("."))) Then
			Dim pos = ET.SelectionStart -1 As Int
			If pos < 0 Then pos = 0
			ET.Text = Old			
			ET.SelectionStart = pos
		End If
	Catch
	End Try
	NewValue = ET.Text
End Sub

Sub EditTextPLCToReg_FocusChanged (HasFocus As Boolean)
	If Not(HasFocus) Then
		EditTextPLCToReg_EnterPressed
	Else
		EditTextPLCToReg.Text = PLCreg.Value		
	End If
End Sub

Sub EditTextPLCToReg_EnterPressed
	Dim ET = Sender As EditText
	If ET.Text <> "" Then
		Dim args As StartWriteValueToPLCArguments
		args.PLCreg = PLCreg
		args.NewValue = ET.Text * Power(10,exponent)
		args.SourcePresentation = Me
		CallSubDelayed2(ServiceCom,"StartWriteValueToPLC",args)
	End If
End Sub

 