﻿Type=StaticCode
Version=2.52
@EndOfDesignText@
'This code module has:
'	-An Array that keep all PLCRegister Object
'	-Code to construct string for sending register values to PLC
'	-Code to extract register values from the string received from PLC

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Dim PLCRegisterMaxIndex = 8 As Int
	Dim PLCRegister(PLCRegisterMaxIndex+1) As PLCRegister

	Dim requestFunctionRead = 3 As Byte
	Dim requestFunctionWrite = 16 As Byte

	Dim ActiveRequestFunction As Byte
	Dim ActiveRequestNumberOfBytes As Short
	Dim ActiveRequestSuccessfull As Boolean
	Dim activeRequestFinished As Boolean
	Dim ActiveRequestStartAdress As Byte
	Dim ActiveRequestMessage As String
	
End Sub

Sub Initialize
		For i = 1 To PLCRegisterMaxIndex
			Dim PLCreg As PLCRegister
			PLCreg.Initialize(i)
			PLCRegister(i) = PLCreg
		Next
End Sub

Sub StartRead(fromAddress As Byte, toAddress As Byte, 	Stream As AsyncSteamsText) As String
        Dim writeBuffer() As Byte
		Dim bc As ByteConverter
		ActiveRequestFunction= requestFunctionRead
		ActiveRequestNumberOfBytes = (toAddress - fromAddress + 1) * 2
		ActiveRequestStartAdress = fromAddress
		writeBuffer = Array As Byte(4, ActiveRequestFunction, 0, 0, 255, fromAddress - 1,ActiveRequestNumberOfBytes)
		Dim checksum(1) As Byte
		checksum(0) = calculateChecksum(writeBuffer) 
		Stream.Write(":" & bc.HexFromBytes(writeBuffer) & bc.HexFromBytes(checksum)  & Chr(13) & Chr(10))
End Sub 

Sub StartWrite(fromAddress As Byte, toaddress As Byte, dataBuffer() As Short, 	Stream As AsyncSteamsText)
	ActiveRequestFunction = requestFunctionWrite
	ActiveRequestNumberOfBytes = (toaddress - fromAddress + 1) * 2
	ActiveRequestStartAdress = fromAddress
	Dim bc As ByteConverter
	Dim BodyString = bc.HexFromBytes(Array As Byte (4, ActiveRequestFunction, 0, 0, 255, fromAddress - 1, ActiveRequestNumberOfBytes)) & bc.HexFromBytes(bc.ShortsToBytes(dataBuffer )) As String
	
	For i = fromAddress To toaddress
		PLCRegister(i).SetNewValue(dataBuffer(i-fromAddress))
	Next

	If Stream.IsInitialized Then
		Stream.Write(":" & BodyString & calculateChecksum(bc.HexToBytes(BodyString)) & Chr(13) & Chr(10))
	Else
		Log(":" & BodyString & calculateChecksum(bc.HexToBytes(BodyString)) & "|-----------------")
	End If
End Sub


Sub calculateChecksum(buffer() As Byte) As Byte
    Dim Checksum As Short
    For I = 0 To buffer.Length - 1
        'Checksum = (Checksum + buffer(i)) AND 255
		Checksum = Bit.AND(Checksum + buffer(I),255)
    Next
    Return Bit.AND((255 - Checksum + 1) ,255)
End Sub


Public Sub Parse(Answer As String)	

'Removed this code to keep it seecret

End Sub