﻿Type=Class
Version=2.52
@EndOfDesignText@
'Objects made from this class do this:
'	-Keep the value from one register read from the PLC
'	-Keeps track of the status of the value, if it is read from the PLC, and if the value can be trusted due to writing and reading from the PLC
'	-Keeps a List of "Presentation"-objects that depend on the object
'	-Informs the "Presentation"-objects when the Value or status of the Object has changed through the "interface" Sub PLCregValueChanged()


Sub Class_Globals
	Private pValue As Short
	Private pLoaded As Boolean
	Private pThrustable As Boolean
	Private pNewValueSentButNotConfirmed As Boolean
	Public NewValueReceived As Boolean
	Private pNewValue As Short
	Private pIndex As Short
	Private PresentationsList As List	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Index As Short)
	pIndex = Index
	PresentationsList.Initialize
	PLC.PLCRegister(Index) = Me
End Sub

Public Sub SetValue(Value As Short)
	If pLoaded = False OR pThrustable = False OR pValue <> Value Then
		pValue = Value
		pThrustable=True
		pLoaded=True
		If pNewValueSentButNotConfirmed AND pNewValue = Value Then
			pNewValueSentButNotConfirmed = False
		End If
		InformListeningPresentations
	End If
End Sub

Public Sub SetNewValue(Value As Short)
	pNewValue = Value
	pThrustable = False	
	pNewValueSentButNotConfirmed = True
	InformListeningPresentations
End Sub

Public Sub Value() As Short
	Return pValue
End Sub

Public Sub Loaded() As Boolean
	Return pLoaded
End Sub

Public Sub Thrustable() As Boolean
	Return pThrustable
End Sub

Public Sub NewValueSentButNotConfirmed() As Boolean
	Return pNewValueSentButNotConfirmed
End Sub

Public Sub Index() As Short
	Return pIndex
End Sub

Public Sub AddPresentation(Presentation As Object)
	PresentationsList.Add(Presentation)
End Sub

Public Sub RemovePresentation(Presentation As Object)
	Try
		PresentationsList.RemoveAt(PresentationsList.IndexOf(Presentation))
	Catch
		ToastMessageShow(LastException.Message,True)
	End Try
End Sub

Private Sub InformListeningPresentations
	For Each Presentation As Object In PresentationsList
		CallSub(Presentation,"PLCregValueChanged")
	Next
End Sub